<template>
<el-form v-if="currency.initialized" @submit.prevent.stop="submit" label-width="120px">
  <p>Send a transaction:</p>
  
  <el-form-item label="Address">
    <el-input placeholder="Address" v-model="address" />
  </el-form-item>

  <el-form-item label="Amount">
    <el-input placeholder="Amount" v-model="amount" />
  </el-form-item>

  <div v-if="error">{{ error }}</div>
  
  <el-form-item label="Fee">
    <el-select v-model="fee">
      <el-option v-for="fee in feeRates" :value="fee.tier">{{fee.tier}}</el-option>
    </el-select>
  </el-form-item>
  
  <el-form-item>
    <el-button @click="submit">Submit</el-button>
  </el-form-item>
</el-form>
</template>
<script>

export default {
  props: ['currency'],
  data() {
    return {
      address: null,
      amount: 0,
      fee: 0,
      feeRates: null,
    };
  },
  
  methods: {
    async submit() {
      const { error, result } = await this.currency.send(this.address,this.amount,this.fee);
      
      if(error) this.error = error;
      else {
        console.log("RESULT! ",result);
      }
    },
  },

  watch: {
    currency: {
      async handler() {
        this.feeRates = null;
        this.error = null;
        
        const { result: blockchain, error: error } = await this.currency.wallet.blockset.net(`blockchains/${this.currency.blockchainId}`);
        if(error) {
          this.error = error;
          return;
        }

        this.feeRates = blockchain.fee_estimates;
      },
      immediate: true
    }
  }
  
};

</script>
